/*
##############################################################################
#
# Copyright by The HDF Group.
# All rights reserved.
#
# This file is part of the hl_region High-Level HDF5 APIs.  The full copyright
# notice, including terms governing use, modification, and redistribution,
# is contained in the file COPYING, which can be found at the root of the
# source code distribution tree and in the documentation directory (doc/html/).
# If you do not have access to this file, you may request a copy of
# "the hl_region High-Level HDF5 APIs copyright and license statement" from
# help@hdfgroup.org.
#
##############################################################################
*/

#ifndef _hl_regionf90proto_H
#define _hl_regionf90proto_H

#include "H5public.h"

/* H5LR functions */

H5_FCDLL int_f H5LRget_region_info_c(hid_t_f *obj_id, void *ref, size_t_f *pathlen,                
				     _fcd path, int_f *path_size, int_f *rank, hid_t_f *dtype, 
				     int_f *sel_type, size_t_f *numelem, void *buf);

H5_FCDLL int_f H5LRcreate_region_references_c(hid_t_f *file_id, size_t_f *num_elem, char *path, 
					      int_f *char_len, int_f *max_char_size, 
					      int_f *block_coord_size, 
					      const hsize_t_f *block_coord, void *ref_buf );

H5_FCDLL int_f H5LRread_region_c(hid_t_f *loc_id, void *ref, hid_t_f *mem_type, size_t_f *num_elem, void *buf );


H5_FCDLL int_f H5LRmake_dataset_c(hid_t_f *loc_id, size_t_f *pathlen,                
				  char *path, hid_t_f *type_id, size_t_f *buf_size,
				  void *loc_id_ref, void *ref);

H5_FCDLL int_f H5LRcopy_region_c(hid_t_f *obj_id, void *ref, size_t_f *file_dest_len,                
				 char *file_dest, size_t_f *path_dest_len, char *path_dest, int_f *rank,
				 hsize_t_f *block_coord_dest);

H5_FCDLL int_f H5LRcopy_reference_c(hid_t_f *obj_id, void *ref, size_t_f *file_len,                
				    char *file, size_t_f *path_len, char *path, int_f *rank,
				    hsize_t_f *block_coord, void *ref_new);

H5_FCDLL int_f H5LRcreate_ref_to_all_c(hid_t_f *loc_id, size_t_f *group_path_len, char *group_path, 
				       size_t_f *ds_path_len, char *ds_path, 
				       int_f *index_type, int_f *order, int_f *ref_type);

/* H5LT functions */

H5_FCDLL int_f H5LTread_region_c(char *file, char *path, int_f *filelen, int_f *pathlen, 
				 const hsize_t_f *block_coord, int_f *rank, hid_t_f *mem_type, void *buf);

H5_FCDLL int_f H5LTcopy_region_c(char *file_src,  int_f *file_src_len, char *path_src,  int_f *path_src_len, 
				 const hsize_t_f *block_coord_src, int_f *block_src_rank, 
				 char *file_dest,  int_f *file_dest_len, char *path_dest,  int_f *path_dest_len, 
				 const hsize_t_f *block_coord_dest, int_f *block_dest_rank);

H5_FCDLL int_f H5LTread_bitfield_value_c(hid_t_f *dset_id, int_f *num_values, int_f *offset,
					 int_f *lengths, hid_t_f *space, int_f *buf);

/* external functions */

extern char *HD5f2cstring(_fcd fdesc, size_t len);
extern void HD5packFstring(char *src, char *dest, size_t dst_len);

#endif /* _hl_regionf90proto_H */
